Bug 826037 - Review Request: prefuse - Java Visualization Toolkit
Review Request: prefuse - Java Visualization Toolkit
Status: NEW
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-JAVASIG
  Show dependency treegraph
 
Reported: 2012-05-29 08:48 EDT by gil cattaneo
Modified: 2015-12-04 00:17 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2012-05-29 08:48:14 EDT
Spec URL: http://gil.fedorapeople.org/prefuse.spec
SRPM URL: http://gil.fedorapeople.org/prefuse-20071021-1.fc16.src.rpm
Description: Prefuse supports a rich set of features for data modeling,
visualization, and interaction. It provides optimized data
structures for tables, graphs, and trees, a host of layout
and visual encoding techniques, and support for animation,
dynamic queries, integrated search, and database connectivity.
Prefuse is written in Java, using the Java 2D graphics library,
and is easily integrated into Java Swing applications or web
applets.
Fedora Account System Username: gil

tested on: http://koji.fedoraproject.org/koji/taskinfo?taskID=4111509
Comment 1 Mikolaj Izdebski 2012-07-29 10:21:03 EDT
The release number is wrong. Since you are packaging a beta release, the release tag should start with 0. See: http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Pre-Release_packages
Comment 3 gil cattaneo 2012-07-29 12:01:37 EDT
tested on http://koji.fedoraproject.org/koji/taskinfo?taskID=4340184
Comment 5 Cleber Rosa 2013-11-20 22:19:10 EST
Does the following mean that the users of this package won't find the features that are upstream?

# deprecated
rm ./src/prefuse/data/search/LuceneSearcher.java

Or it compensated by the system wide lucene? What about KeywordSearchTupleSet.java? Does it impact the API users will see and get?

The following is certainly a matter of style, but I believe is clearer:

%build

CLASSPATH=$(build-classpath lucene mysql-connector-java junit ant/ant-junit):build/prefuse/classes
export CLASSPATH

Other than that, rpmlint comes out clean and the package itself builds and installs just fine.
Comment 6 Cleber Rosa 2013-11-20 23:02:24 EST
One more comment: I have noticed that the change log contains a single entry.

I've found that it's actually helpful to populate the change log even during the review and bump the release number as changes occur it helps to keep track of the most current version.
Comment 7 Cleber Rosa 2013-11-20 23:29:08 EST
A nitpick:

install -pm 644 build/%{name}.jar \
  %{buildroot}%{_javadir}/%{name}.jar

Could simply be:

install -pm 644 build/%{name}.jar %{buildroot}%{_javadir}/
Comment 8 Cleber Rosa 2013-11-20 23:30:06 EST
INFORMAL REVIEW:

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
[x]: Bundled jar/class files should be removed before build

Maven:
[x]: Pom files have correct Maven mapping
     Note: Some add_maven_depmap calls found. Please check if they are correct
     or update to latest guidelines
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in prefuse-
     javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: prefuse-20071021-0.1.beta.fc19.noarch.rpm
          prefuse-demos-20071021-0.1.beta.fc19.noarch.rpm
          prefuse-javadoc-20071021-0.1.beta.fc19.noarch.rpm
          prefuse-20071021-0.1.beta.fc19.src.rpm
4 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint prefuse-javadoc prefuse prefuse-demos
3 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
prefuse-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

prefuse (rpmlib, GLIBC filtered):
    java
    jpackage-utils

prefuse-demos (rpmlib, GLIBC filtered):
    jpackage-utils
    prefuse



Provides
--------
prefuse-javadoc:
    prefuse-javadoc

prefuse:
    mvn(org.prefuse:prefuse)
    prefuse

prefuse-demos:
    mvn(org.prefuse:demos)
    prefuse-demos



Source checksums
----------------
http://repo1.maven.org/maven2/org/prefuse/demos/beta-20060220/demos-beta-20060220.pom :
  CHECKSUM(SHA256) this package     : d7f4e20e85541df4da62069b16e009809bc80130d13b800da484fa879699e6e4
  CHECKSUM(SHA256) upstream package : d7f4e20e85541df4da62069b16e009809bc80130d13b800da484fa879699e6e4
http://sourceforge.net/projects/prefuse/files/prefuse/beta-20071021/prefuse-beta-20071021.zip :
  CHECKSUM(SHA256) this package     : c816d4182c31e23ecb63470ea009a70dfedc76dc8e3a0af8f240867047526b2d
  CHECKSUM(SHA256) upstream package : c816d4182c31e23ecb63470ea009a70dfedc76dc8e3a0af8f240867047526b2d
http://repo1.maven.org/maven2/org/prefuse/prefuse/beta-20071021/prefuse-beta-20071021.pom :
  CHECKSUM(SHA256) this package     : 84da4f559611ee1e504abf270762306806b5fc321663f26e47e5ccfb6abaca14
  CHECKSUM(SHA256) upstream package : 84da4f559611ee1e504abf270762306806b5fc321663f26e47e5ccfb6abaca14


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 826037
Buildroot used: fedora-19-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 9 gil cattaneo 2013-11-21 02:24:07 EST
(In reply to Cleber Rodrigues from comment #5)
> Does the following mean that the users of this package won't find the
> features that are upstream?
> 
> # deprecated
> rm ./src/prefuse/data/search/LuceneSearcher.java
> 
> Or it compensated by the system wide lucene? What about
> KeywordSearchTupleSet.java? Does it impact the API users will see and get?
>

this package use lucene 1.4.3, and for what i need, removing these sources, it more than good. if some user will need to support new releases of lucene will have to provide a patch

compile-prefuse:
     [copy] Copying 35 files to ~/BUILD/prefuse-beta/build/prefuse/classes
    [javac] Compiling 355 source files to ~/BUILD/prefuse-beta/build/prefuse/classes
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/KeywordSearchTupleSet.java:9: error: cannot find symbol
    [javac] import org.apache.lucene.search.Hits;
    [javac]                                ^
    [javac]   symbol:   class Hits
    [javac]   location: package org.apache.lucene.search
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:14: error: cannot find symbol
    [javac] import org.apache.lucene.search.Hits;
    [javac]                                ^
    [javac]   symbol:   class Hits
    [javac]   location: package org.apache.lucene.search
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:168: error: cannot find symbol
    [javac]     public Hits search(String query) throws ParseException, IOException {
    [javac]            ^
    [javac]   symbol:   class Hits
    [javac]   location: class LuceneSearcher
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/KeywordSearchTupleSet.java:20: warning: [deprecation] Searcher in org.apache.lucene.search has been deprecated
    [javac]  * engine supporting full text indexing and keyword search. Please refer to
    [javac]                                                        ^
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/KeywordSearchTupleSet.java:90: error: cannot find symbol
    [javac]             Hits hits = m_lucene.search(query);
    [javac]             ^
    [javac]   symbol:   class Hits
    [javac]   location: class KeywordSearchTupleSet
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/KeywordSearchTupleSet.java:155: error: cannot find symbol
    [javac]         d.add(Field.Text(LuceneSearcher.FIELD, text, m_storeTermVectors));
    [javac]                    ^
    [javac]   symbol:   method Text(String,String,boolean)
    [javac]   location: class Field
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/KeywordSearchTupleSet.java:156: error: cannot find symbol
    [javac]         d.add(Field.Keyword(LuceneSearcher.ID, String.valueOf(id)));
    [javac]                    ^
    [javac]   symbol:   method Keyword(String,String)
    [javac]   location: class Field
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:42: warning: [deprecation] Searcher in org.apache.lucene.search has been deprecated
    [javac]     private Searcher searcher;
    [javac]             ^
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:86: error: no suitable constructor found for StandardAnalyzer()
    [javac]         analyzer = new StandardAnalyzer();
    [javac]                    ^
    [javac]     constructor StandardAnalyzer.StandardAnalyzer(Version,Reader) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor StandardAnalyzer.StandardAnalyzer(Version,File) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor StandardAnalyzer.StandardAnalyzer(Version) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor StandardAnalyzer.StandardAnalyzer(Version,Set<?>) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:89: error: no suitable constructor found for IndexWriter(Directory,Analyzer,boolean)
    [javac]             writer = new IndexWriter(directory, analyzer, !readOnly);
    [javac]                      ^
    [javac]     constructor IndexWriter.IndexWriter(Directory,IndexWriterConfig) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,IndexDeletionPolicy,MaxFieldLength,IndexCommit) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,boolean,IndexDeletionPolicy,MaxFieldLength) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,IndexDeletionPolicy,MaxFieldLength) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,MaxFieldLength) is not applicable
    [javac]       (actual argument boolean cannot be converted to MaxFieldLength by method invocation conversion)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,boolean,MaxFieldLength) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:130: error: no suitable constructor found for IndexWriter(Directory,Analyzer,boolean)
    [javac]                 writer = new IndexWriter(directory, analyzer, false);
    [javac]                          ^
    [javac]     constructor IndexWriter.IndexWriter(Directory,IndexWriterConfig) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,IndexDeletionPolicy,MaxFieldLength,IndexCommit) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,boolean,IndexDeletionPolicy,MaxFieldLength) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,IndexDeletionPolicy,MaxFieldLength) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,MaxFieldLength) is not applicable
    [javac]       (actual argument boolean cannot be converted to MaxFieldLength by method invocation conversion)
    [javac]     constructor IndexWriter.IndexWriter(Directory,Analyzer,boolean,MaxFieldLength) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:139: warning: [deprecation] optimize() in IndexWriter has been deprecated
    [javac]                     writer.optimize();
    [javac]                           ^
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:172: error: method parse in class QueryParser cannot be applied to given types;
    [javac]                 q = QueryParser.parse(query, fields[0], analyzer);
    [javac]                                ^
    [javac]   required: String
    [javac]   found: String,String,Analyzer
    [javac]   reason: actual and formal argument lists differ in length
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:174: error: no suitable method found for parse(String,String[],Analyzer)
    [javac]                 q = MultiFieldQueryParser.parse(query, fields, analyzer);
    [javac]                                          ^
    [javac]     method MultiFieldQueryParser.parse(Version,String[],String[],Occur[],Analyzer) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method MultiFieldQueryParser.parse(Version,String,String[],Occur[],Analyzer) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method MultiFieldQueryParser.parse(Version,String[],String[],Analyzer) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method QueryParser.parse(String) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:176: error: no suitable method found for search(Query)
    [javac]             return searcher.search(q);
    [javac]                            ^
    [javac]     method Searcher.search(Weight,Filter,int,Sort) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Weight,Filter,int) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Weight,Filter,Collector) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Query,int) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Query,Filter,int) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Query,Filter,Collector) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Query,Collector) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Query,int,Sort) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searcher.search(Query,Filter,int,Sort) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searchable.search(Weight,Filter,int,Sort) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searchable.search(Weight,Filter,int) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac]     method Searchable.search(Weight,Filter,Collector) is not applicable
    [javac]       (actual and formal argument lists differ in length)
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:197: error: cannot find symbol
    [javac]             Hits hits = search(query);
    [javac]             ^
    [javac]   symbol:   class Hits
    [javac]   location: class LuceneSearcher
    [javac] ~/BUILD/prefuse-beta/build/prefuse/src/prefuse/data/search/LuceneSearcher.java:276: warning: [deprecation] Searcher in org.apache.lucene.search has been deprecated
    [javac]     public Searcher getIndexSearcher() {
    [javac]            ^
    [javac] Note: Some input files use unchecked or unsafe operations.
    [javac] Note: Recompile with -Xlint:unchecked for details.
    [javac] 13 errors
    [javac] 4 warnings

other questions of "style" for me are irrelevant

regards
Comment 14 Upstream Release Monitoring 2015-12-04 00:17:09 EST
gil's scratch build of prefuse-20071021-0.2.beta.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12046417

Note You need to log in before you can comment on or make changes to this bug.